---
title: "Background"
---


## The "Framework" Question

In the nuclear and particle physics communities many software frameworks exists.
They come in all sizes and scopes. 
It is important to remember why frameworks exist: to solve a problem that is more difficult without the framework. 
That said, adopting a framework introduces tight coupling in software which makes it inflexible and difficult to maintain.
Therefore, ***adopting a framework for the sake of using a framework is never a good idea***.

### The "geometry problem"

The detector description framework called `DD4hep`, at its core, is aimed at 
solving the "geometry problem". The geometry problem relates the detector 
description used in simulation or experiment and the reconstruction geometry.
An illustrative example is the following. Give a channel number representing a 
pixel in a silicon detector, a hit in that channel represents a 3D point with 
an uncertainty equal to dimensions of the pixel. Constructing the pixel in 
simulation and providing a robust look of the geometry based on a channel 
number are very different tasks.

A tool or framework that allows this look up of geometry from channel number is 
important for flexible use of independent tracking and reconstruction tools. 


