---
title: "Overview"
---

## DD4hep 

DD4hep introduces the concept of a `DetElement` which is related to the volumes (logical volumes) and placed volumes but not in a strict way.
These elements build up a separate tree which describes the relationship between the volumes and the readout detectors. 
Through the unique BitField ID this allows position space information to be mapped to and from channel number/cell ID space.

![DetElement](dd4hep_DetElement.png)

![dd4hep](DD4hep_block_diagram.svg)

## EIC Data model

### PODIO  

The idea is to use plain-old-datatype IO. PODIO stamps out structs based on yaml files.

### LCIO2 

The old LCIO data model  is used as a starting point for our data model and it is called `lcio2`.
It is [defined in yaml file](https://eicweb.phy.anl.gov/EIC/podio/blob/master/lcio2/lcio-edm.yaml) 
which is used to generate C++ library.

- Eicweb fork: https://eicweb.phy.anl.gov/EIC/podio
- AIDAsoft repo: https://github.com/AIDASoft/podio

![data model use](data_model_use2.png)


## NPDet - Nuclear physics detector library

As we will learn the compact detector description files are used to build detectors from a parameterized detector library. 
NPDet is a collection of _generic detectors_ and _concept detectors_. 

In a hack-a-thon we will add to this detector library.


## Reconstruction and Tracking Tools

The goal of having a robust detector library and data model is to aid in the use and development of new tools, techniques, and algorithms.

Many external tools exist that can be applied along the path to the ultimate physics analysis.

See the [useful links](links) for a list of tools.



